//After changing storage we move current folder to /
//If we change storage or current location, we need to remove all selections and set total size of selected files to 0.
var filesSeparator = ';';
var storageCookie = 'FileManagerStorage';
var storageRadioItems = new Array( 'FileManager-Button-InternalMemory', 'FileManager-Button-UsbKey' );

function initFileManager()
{
	// Define the callbacks for the asyncRequest
	var callbacks =
	{

		revive : function (k,v)
		{

			if (k == "DateTime")
			{
				try
				{
					return YAHOO.lang.JSON.stringToDate(v);
				}
				catch (x) {
					YAHOO.log("ERROR: JSON revive failed!");
				}
			}
	
			return v;
		},

		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText, callbacks.revive);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initFileManager()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));

			// Get config
			var config = data.ConfigFileManager;
			if (config == null) return;

			// -- Internal Memory --
			setItemText('FileManager-Item-IntMem-PercentFree', config.InternalMemory.PercentFree);
			setItemText('FileManager-Item-IntMem-SizeUsed', formatTextAsMemorySize(config.InternalMemory.SizeUsed));
			setItemText('FileManager-Item-IntMem-SizeFree', formatTextAsMemorySize(config.InternalMemory.SizeFree));
			setItemText('FileManager-Item-IntMem-FileCount', config.InternalMemory.FileCount);

			// -- USB key --
			setItemText('FileManager-Item-UsbKey-PercentFree', config.UsbKey.PercentFree);
			setItemText('FileManager-Item-UsbKey-SizeUsed', formatTextAsMemorySize(config.UsbKey.SizeUsed));
			setItemText('FileManager-Item-UsbKey-SizeFree', formatTextAsMemorySize(config.UsbKey.SizeFree));
			setItemText('FileManager-Item-UsbKey-FileCount', config.UsbKey.FileCount);

			// -- Storage Location for Recording --
			setItemText('FileManager-Item-RecordingStorageLocation', getStorageLocation( config.RecordingStorageLocation ) );
			
			// -- Storage Location for Session --
			var text = getStorageLocation( config.SessionStorageLocation );
			if (config.SessionFileMove != null)
			{
				text += " {0} {1} ".format(getResource('FileManager-Resource-AndMovedTo'), getStorageLocation(config.SessionFileMove));
				if (config.SessionFileMoveDirectory != null && config.SessionFileMoveDirectory.length > 0)
				{
					text += " ({0})".format(config.SessionFileMoveDirectory);
				}
			}
			setItemText('FileManager-Item-SessionStorageLocation',  text);
				
			//External ftp
			setFieldValue( 'FileManager-Field-Ftp-Server', config.Ftp.Server );
			setFieldValue( 'FileManager-Field-Ftp-Port', config.Ftp.Port );
			setFieldValue( 'FileManager-Field-Ftp-Username', config.Ftp.Username );
			setFieldValue( 'FileManager-Field-Ftp-Password', config.Ftp.Password );
			setFieldValue( 'FileManager-Field-Ftp-Path', config.Ftp.Path );
			
				
			var storage = YAHOO.util.Cookie.get( storageCookie );
			if ( storage != null )
			{
				checkRadioButton( storageRadioItems, storage );
			}
			
			setFieldValue( 'FileManager-SelectedFiles', '' );
			
			requestFileList();
			// Show form
			showConfigForm();
		},

		failure : function (o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry
			setTimeout("initFileManager()", 5000);
		},

		timeout : 10000,
		cache : false
    };

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigFileManagerURL, callbacks);

	YAHOO.util.Event.addListener( 'FileManager-Button-InternalMemory', 'click', onStorageChanged );
	YAHOO.util.Event.addListener( 'FileManager-Button-UsbKey', 'click', onStorageChanged );
	
	makeFieldValidator( 'FileManager-Field-Ftp-Server', 'validating_Host' );
	makeFieldValidator('FileManager-Field-Ftp-Port', 'validating_Port' );
}

function requestFileList()
{
	var callbacks =
	{
		success : function (o)
		{
			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				//setTimeout("location.reload()", 5000);
				setTimeout("requestFileList()", 5000);
				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			var config = data.ConfigFileList;
			if (config == null) return;
			
			// Get path
			var path = (config.Path != null  ? config.Path : '/');
			if (path.length == 0 || path[path.length - 1] != '/') path += '/';
			
			// Set current path (for next POST)
			setFieldValue('FileManager-CurrentPath', path );
			
			// Show current folder
			setItemText('FileManager-CurrentFolder', path);
			
			setFieldChecked( 'FileManager-Button-InternalMemory', config.Storage == 0 );
			setFieldChecked( 'FileManager-Button-UsbKey', config.Storage == 2 );
			
			updateSelectedFilesField( config.Files );
			
			var fileView = new FileTableView(config.Files);
		},
		failure : function(o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
					YAHOO.log("ERROR: Async call failed!");
			}
				
			// Retry
			setTimeout("requestFileList()", 5000);
		},

		timeout : 10000,
		cache : false
	};
	
	//Show user that we processing his request
	var div = YAHOO.util.Dom.get('FileTableView');
	div.innerHTML = getResource('FileManager-Resource-Loading');
	
	var path = getFieldValue('FileManager-CurrentPath');
	var url = getFileListURL + '&Storage=' + getStorageFieldValue() + '&Path=' + path;
	
	YAHOO.util.Connect.asyncRequest('GET', url, callbacks);
}

function FileTableView(source)
{
	// Columns definition
	var headerCheckbox = '<input type=\"checkbox\" id="FileManager-TableHeader-NameCheckbox"' + ' class=\"' + 'yui-dt-checkbox'  + '\" />';
	var nameLabel = getResource( 'FileManager-Resource-Name' );

	//Try to duplicate exist field
	//I'm not sure that it is a best way to do this, but haven't found better way
	for( var i in source )
	{
		source[ i ].dummy = 'dummy';
	}
	
	var myColumnDefs =
	[
		{label:headerCheckbox, key:'dummy', formatter:FileTableView.checkboxFormatter, resizeable:false, sortable:false },
		{label:nameLabel, key:"Name", width:345, formatter:FileTableView.formatFilename, resizeable:true, sortable:true },
		{label:getResource('FileManager-Resource-Size'), key:"Size", formatter:FileTableView.formatSize, resizeable:true, sortable:true},
		{label:getResource('FileManager-Resource-Type'), key:"Type", hidden:true, formatter:FileTableView.formatType, resizeable:true, sortable:true},
		{label:getResource('FileManager-Resource-CreationDate'), key:"CreationDate", hidden:true, formatter:FileTableView.formatDateTime, resizeable:true, sortable:true},
		{label:getResource('FileManager-Resource-ModificationDate'), key:"ModificationDate", formatter:FileTableView.formatDateTime, resizeable:true, sortable:true},
		{label:'', key:'InUse', hidden:true}
	];

	// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema =
	{
		fields: [ "dummy", "Name","Size","Type","CreationDate","ModificationDate","InUse"]
	};
	
	myDataSource.doBeforeCallback = function( req, raw, res, cb )
	{
		//We don't need to do anything if G-Files isn't checked.
		if ( !isFieldChecked( 'FileManager-Files-GFile' ) )
			return res;
		
		var filtered = [];
		for( var i in res.results )
		{
			//This is just file, so do not use it
			if ( res.results[ i ].Type != 2 )
			{
				filtered.push( res.results[ i ] );
			}
		}		
		res.results = filtered;
		return res;
	};

	// Table configs
	var myConfigs = {
		width:"auto",
		height:"auto"
	};

	// Localized messages
	myConfigs.MSG_EMPTY = getResource('FileManager-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('FileManager-Resource-Loading');
	myConfigs.MSG_SORTASC = getResource('FileManager-Resource-SortAsc');
	myConfigs.MSG_SORTDESC = getResource('FileManager-Resource-SortDesc');

	// Create table
	var myDataTable = new YAHOO.widget.ScrollingDataTable("FileTableView", myColumnDefs, myDataSource, myConfigs);
	
    var filterTimeout = null;
    var updateFilter  = function ()
	{
        // Reset timeout
        filterTimeout = null;

        // Reset sort
        var state = myDataTable.getState();

        // Get filtered data
       myDataSource.sendRequest('request',{
            success : myDataTable.onDataReturnInitializeTable,
            failure : myDataTable.onDataReturnInitializeTable,
            scope   : myDataTable,
            argument: state
        });
    };


	var rowClick = function toFolder( event )
	{
		var target = event.target;
		var record = myDataTable.getRecord( target );
		var path = getFieldValue('FileManager-CurrentPath');
		
		if( record.getData('Type') != 0 )
			return;

		var requestPath = record.getData( 'Name' ) + '/';
		if ( requestPath == '../' )
		{
			requestPath = '';
			
			if ( path.length < 2 )
				return;
				
			path = path.substr( 0, path.lastIndexOf( '/', path.length - 2 ) ); 
		}
			
		if( path[ path.length - 1 ] != '/' )
			path += '/';
			
		path += requestPath;

		setFieldValue( 'FileManager-CurrentPath', path );
		changeLocation();
	};
	
	var checkboxClick = function onCheckboxClick( event )
	{
		var target = event.target;
		var record = myDataTable.getRecord( target );
		var name = record.getData( 'Name' );
		
		var isSelected = isFieldChecked( name );
		
		if ( isFieldChecked( name ) )
			selectFile( name, record, myDataTable );
		else
			unSelectFile( name, record, myDataTable );
	};
	
	//myDataTable.subscribe( "rowClickEvent", rowClick );
	myDataTable.subscribe( "checkboxClickEvent", checkboxClick );
	myDataTable.subscribe( "linkClickEvent", rowClick );
	
    YAHOO.util.Event.on('FileManager-Files-GFile','click',function (e) {
        clearTimeout(filterTimeout);
        setTimeout(updateFilter,600);
    });
	
	YAHOO.util.Event.on( 'FileManager-TableHeader-NameCheckbox', 'click', function(e){ onHeaderCheckboxClick( myDataTable ); } );
	
	initSelectedFilesSize( myDataTable );
	if ( isAllFilesSelected( myDataTable ) )
		setFieldChecked( 'FileManager-TableHeader-NameCheckbox', true );
		
	function updateTable()
	{
		myDataTable.showTableMessage(getResource('FileManager-Resource-Loading'));
		myDataTable.getDataSource().sendRequest('', { success: myDataTable.onDataReturnInitializeTable, scope: myDataTable });
	}
	
	YAHOO.util.Event.addListener('timezone', 'change', updateTable );
}


function formatTextAsFileSize(size)
{
	return formatTextAsMemorySize( size );
}

FileTableView.checkboxFormatter = function( elem, record, column, data )
{
	var id = record.getData('Name');
	var checked = isFileSelected( id ) ? 'checked="checked"' : '';
	var checkbox = '<input type="checkbox" id="' + id + '" ' + checked + ' class="yui-dt-checkbox" />';
	if( id == '..' || record.getData( 'InUse' ) )
		return;
	elem.innerHTML = checkbox;
};
FileTableView.formatText = function( elem , record , oColumn , data)
{	
	elem.innerHTML = data;
	markInUse( record, elem );
};

FileTableView.formatFilename = function( elem, record, column, data )
{
	//0 - folder
	//1 - G-File
	//2 - File
	//3 - Ring File
	var link = 'javascript:void(0);';
	var prefix = getStorageFieldValue() == 0 ? '/nand' : '/usb';
	var path = getFieldValue('FileManager-CurrentPath');
	var d = new Date();
	
	switch( record.getData( 'Type' )  )
	{
		case 0:
			if ( data == '..' )
			{
				YAHOO.util.Dom.addClass( elem, 'filemngr-parent-folder' );
			}
			else
			{
				YAHOO.util.Dom.addClass( elem, 'filemngr-folder' );
			}
			break;
		case 1:
			link = '{0}{1}{2}'.format( prefix, path, data );
			YAHOO.util.Dom.addClass( elem, 'filemngr-gfile' );
			break;
		case 2:
			link = '{0}{1}{2}?{3}'.format( prefix, path, data, d.getTime() );
			YAHOO.util.Dom.addClass( elem, 'filemngr-file' );
			break;
		case 3:
			link = null; // Cannot click on Ring File
			YAHOO.util.Dom.addClass( elem, 'filemngr-ringfile' );
			break;
	}
	
	var prefix = getStorageFieldValue() == 0 ? '/nand' : '/usb';
	var path = getFieldValue('FileManager-CurrentPath');
	var str = link != null ? '<a href="{0}">{1}</a>'.format( link, data ) : '<span>{0}</span>'.format(data);

	elem.innerHTML = str;
	markInUse( record, elem );
};

FileTableView.formatSize = function(elem, record, oColumn, data)
{
	if (record.getData('Type' ) != 0)
	{
		elem.innerHTML = formatTextAsFileSize( data);
	}
	else
	{
		elem.innerHTML = "";
	}
	markInUse( record, elem );
};

FileTableView.formatType = function( elem, record, column, data )
{
	var text = "";
	switch(data)
	{
		case 0: text = getResource('FileManager-Resource-Dir'); break;
		case 1: text = getResource('FileManager-Resource-GFile');break;
		case 2: text = getResource('FileManager-Resource-File');break;
		case 3: text = "Ring File"; break;
	}
	elem.innerHTML = text;
	markInUse( record, elem );
};
FileTableView.formatDateTime = function(elem, record, oColumn, data)
{
	try
	{
		if (data != 'null' )
		{
			var text = datetimeToCurrentTimezone( data ).full;
			elem.innerHTML = text;
			markInUse( record, elem );
		}
	}
	catch (x) {
		YAHOO.log("FileTableView.formatDateTime: '" + data + "' bad format");
	}
};

function markInUse( record, elem )
{
	if ( record.getData( 'InUse' ) )
	{
		YAHOO.util.Dom.addClass( elem, 'filemngr-in-use' );
	}
}
function getStorageLocation( value )
{
	var text = value;
	switch (value)
	{
		case 0: text = getResource('FileManager-Resource-IntMem'); break;
		case 2: text = getResource('FileManager-Resource-UsbKey'); break;
	}
	return text;
}

function getStorageFieldValue()
{
	return getRadioButtonCheckedValue( storageRadioItems );
	//return 0;
}

function onStorageChanged( event )
{
	setFieldValue( 'FileManager-CurrentPath', '/' );
	setItemVisible('FileManager-Button-CopyToUSB', getStorageFieldValue() != 2);
	
	YAHOO.util.Cookie.set( storageCookie, getStorageFieldValue(), { path: "/", expires: new Date("December 31, 2033") });
	
	changeLocation();
}

function onCommand( text )
{
	setFieldValue( 'FileManager-FileOperationType', text );
	
	// Set file count
	var filelist = getFileList();
	
	if ( filelist.length == 1 && filelist[ 0 ] == '' )
	{
		setFieldValue( 'FileManager-FileCount', 0 );
		return;
	}	
	
	setFieldValue('FileManager-FileCount', filelist.length);
	
	try
	{
		// Insert file names after
		var field = YAHOO.util.Dom.get('FileManager-FileCount');	
		for(i in filelist)
		{
			var num = new Number(i) + 1;
			var id = 'FileManager-File-' + num;
			
			if (!YAHOO.util.Dom.inDocument(id))
			{
				var input = document.createElement('input');
				input.id = id;
				input.type = 'hidden';
				input.name = 'File' + num;
				YAHOO.util.Dom.insertAfter(input, field);
			}
			setFieldValue(id, filelist[ i ]);
		}
	}
	catch (x)
	{
	}
}

//TODO: optimize this function. We cna simplify isFileSelected cheks and update size only once
function onHeaderCheckboxClick( table )
{
	var records = table.getRecordSet().getRecords();
	if ( isFieldChecked( 'FileManager-TableHeader-NameCheckbox' ) )
	{
		selectAllFiles( records );
		return;
	}
	else
	{	
		unSelectAllFiles( records );
	}
}

function isFileSelected( name )
{
	var filelist = getFileList();
	return isFileSelectedImpl( name, filelist ); 
}

function isFileSelectedImpl( name, filelist )
{
	for( i in filelist )
	{
		if ( filelist[ i ] == name )
			return true;
	}
	
	return false;
}

function isAllFilesSelected( table )
{
	var set = table.getRecordSet();
	var records = set.getRecords();
	var filelist = getFileList();
	
	for ( var i in records )
	{
		if( !isFileSelectedImpl( records[ i ].getData( 'Name' ), filelist ) )
			return false;
	}
	
	return true;
}

function selectFile( name, record, table )
{
	if ( isFileSelected( name ) )
		return;
		
	var result = getFieldValue( 'FileManager-SelectedFiles');
	
	if ( result.length != 0 )
		result += filesSeparator;
	result += name;
	
	updateSelectedSize( record.getData( 'Size' ), true );
	
	setFieldValue( 'FileManager-SelectedFiles', result );
	
	if ( isAllFilesSelected( table ) )
		setFieldChecked( 'FileManager-TableHeader-NameCheckbox', true );
}

//Do not select file without checkbox
function selectAllFiles( records )
{
	var filelist = getFileList();
	var size = 0;
	var itemSize = 0;
	var result = '';
	var field = null;
	var name = null;
	for ( var i in records )
	{
		name = records[ i ].getData( 'Name' );
		field = YAHOO.util.Dom.get( name );
		if ( field != null )
		{
			result += name + filesSeparator;
			itemSize = parseFloat( records[ i ].getData( 'Size' ) );
			if( !isNaN( itemSize ) )
				size += itemSize;
			setFieldChecked( name, true );
		}
	}
	
	setSelectedFilesSize( size );
	if( result.length > 0 )
		result = result.substr( 0, result.length - 1 );
	setFieldValue( 'FileManager-SelectedFiles', result );
}
	
function unSelectFile( name, record, table )
{
	if ( !isFileSelected( name ) )
		return;
	
	var result = '';
	var filelist = getFileList();
	for ( var i in filelist )
	{
		if ( filelist[ i ] != name )
			result += filelist[ i ] + filesSeparator;
	}
	
	updateSelectedSize( record.getData( 'Size' ), false );
	
	//skip final separator
	//I don't think that length less than 1 is possible, but check it anyway.
	if( result.length > 0 )
		result = result.substr( 0, result.length - 1 );
	setFieldValue( 'FileManager-SelectedFiles', result );
	
	setFieldChecked( 'FileManager-TableHeader-NameCheckbox', false );
}

function unSelectAllFiles( records )
{
	for( var i in records )
	{
		setFieldChecked( records[ i ].getData( 'Name' ), false );
	}
	setFieldValue( 'FileManager-SelectedFiles', '' );
	setSelectedFilesSize( 0 );
}

//If list of files were changed on server we need to remove not existed files
function updateSelectedFilesField( jsonFilelist )
{
	var result = '';
	var filelist = getFileList();
	if( filelist.length < 1 )
		return;
		
	//TODO: it can be donw in more optimal way.	Sort values as example.
	for ( var i in filelist )
	{
		if( filelist[ i ] == '' )
			continue;
			
		for( var j in jsonFilelist )
		{
			if( filelist[ i ] == jsonFilelist[ j ].Name )
			{
				result += filelist[ i ] + filesSeparator;
				break;
			}
		}
	}
	
	if ( result.length > 0 )
		setFieldValue( 'FileManager-SelectedFiles', result.substr( 0, result.length - 1 ) );
}

function getFileList()
{
	return getFieldValue( 'FileManager-SelectedFiles' ).split( filesSeparator );
}

function changeLocation()
{
	var field = YAHOO.util.Dom.get( 'FileManager-TotalFileSize' );
	field.innerHTML = getResource( 'FileManager-Resource-TotalSelection' ) + '';

	setFieldValue( 'FileManager-SelectedFiles', '' );
	setFieldValue( 'FileManager-TotalFileSize-IU', 0 );
	requestFileList();
}

//Detect by mult to increse or decrease size
function updateSelectedSize( value, positive )
{
	if ( value == null )
		return;
		
	var size = 0;
	var current = getFieldValue( 'FileManager-TotalFileSize-IU' );
	//It is ok. We unselect folder, as example.
	if ( current == '' )
		return;
		
	size = parseFloat( current );
	
	if ( !isNaN( size ) )
	{
		size += parseFloat( value ) * ( positive ? 1 : -1 );
	
		setSelectedFilesSize( size );
	}
}

function initSelectedFilesSize( table )
{
	var filelist = getFileList();
	
	var set = table.getRecordSet();
	var records = set.getRecords();
	var size = 0;
	var curSize = 0;
	var name = '';
	
	for( var i in records )
	{
		name = records[ i ].getData( 'Name' );
		if ( isFileSelectedImpl( name, filelist ) )
		{
			curSize = records[ i ].getData( 'Size' );
			if ( curSize != null )
				curSize = parseFloat( curSize );
			
			if ( curSize != null && !isNaN( curSize ) )
				size += curSize;
		}
	}
	
	setSelectedFilesSize( size );
}


function setSelectedFilesSize( size )
{
	setFieldValue( 'FileManager-TotalFileSize-IU', size );
	
	var field = YAHOO.util.Dom.get( 'FileManager-TotalFileSize' );
	field.innerHTML = getResource( 'FileManager-Resource-TotalSelection' ) + formatTextAsFileSize( size );
}