function initRtcBridge()
{
	// Define the callbacks for the asyncRequest
	var callbacks =
	{
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initRtcBridge()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			var config = data.ConfigRtcBridge;
			
			setFieldValue('RtcBridge-Field-Mode', config.Mode );
			setFieldChecked('RtcBridge-Field-Input-UseDataForPvt', config.Input.UseDataForPvt);
			setFieldValue('RtcBridge-Field-Input-Port', config.Input.Port);
			
			setFieldValue('RtcBridge-Field-Output-SerialPort', config.Output.SerialPort);
			
			setConnectionOptions( config.Output.SerialPort );
			
			var selectedPort = document.getElementById('RtcBridge-Field-Output-SerialPort');
			var selectedValue = selectedPort.options[selectedPort.selectedIndex].value;
			
			if (selectedValue == "B" || selectedValue == "F") {
				var select = document.getElementById('RtcBridge-Field-Output-BaudRate');
				var children = select.options;

				for (i = 0; i < children.length; i++) {
					if (parseFloat(children[i].innerHTML,10) > 115200) {
						children[i].disabled = true;
						if (i == select.selectedIndex) {
							select.selectedIndex = 0;
						}
					}
				}
			}
			
			setFieldValue('RtcBridge-Field-Output-Connection', config.Output.ConnectionType );
			setFieldValue('RtcBridge-Field-Output-BaudRate', config.Output.BaudRate);
			setFieldValue('RtcBridge-Field-Output-Mode', config.Output.Mode);
			setFieldChecked('RtcBridge-Field-Output-RtsCts', config.Output.RtsCts);
			
			setOutputMode();
			
			// Show form
			showConfigForm();
		},

		failure : function (o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}

			// Retry
			setTimeout("initRtcBridge()", 5000);
		},

		timeout : 10000,
		cache : false
    };
	
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigRtcBridge, callbacks);
	
	YAHOO.util.Event.addListener( 'RtcBridge-Field-Output-SerialPort', 'change', onSerialPortChanged);
	YAHOO.util.Event.addListener( 'RtcBridge-Field-Output-Mode', 'change', onOutputModeChanged );
	YAHOO.util.Event.addListener( 'RtcBridge-Field-Output-Connection', 'change', onConnectionChanged );
}

function setConnectionOptions( port )
{

	var name = 'RtcBridge-Field-Output-Connection';
	var prevValue = getFieldValue( name );
	
	clearAllFieldOptions(name);
	
	//addFieldOption(name, 'None/Cable', '0');
	addFieldOption(name, getResource('RtcBridge-Field-Output-Connection|0'),'0');
	
	if ( port == "A" )
	{
		addFieldOption(name, 'U-Link TRx', '2');
		addFieldOption(name, 'Magellan UHF', '3');
	}
	
	addFieldOption(name, 'Pacific Crest', '4');
	addFieldOption(name, 'ARF7474B EU', '5');
	addFieldOption(name, 'ARF7474A NA', '6');
	
	setFieldValue( name, prevValue );
}

function setOutputMode()
{
	var port = getFieldValue('RtcBridge-Field-Output-SerialPort');
	enableField('RtcBridge-Field-Output-Mode', true );
	if ( port != "A" )
	{
		setFieldValue('RtcBridge-Field-Output-Mode', '232');
		disableField('RtcBridge-Field-Output-Mode');
	}
	
	var mode = getFieldValue('RtcBridge-Field-Output-Mode');
	setFieldVisible('RtcBridge-Field-Output-RtsCts', true);
	if ( mode == "422" )
	{
		setFieldVisible('RtcBridge-Field-Output-RtsCts', false);
	}
}

function onSerialPortChanged( ev )
{
	var field = YAHOO.util.Event.getTarget( ev );
	setConnectionOptions( field.value );
	setOutputMode();
	
	var selectRate = document.getElementById('RtcBridge-Field-Output-BaudRate');
	var children = selectRate.options;
	
	if (field.value == "B" || field.value == "F") {
		for (i = 0; i < children.length; i++) {
			if (parseFloat(children[i].innerHTML,10) > 115200) {
				children[i].disabled = true;
				if (i == selectRate.selectedIndex) {
					selectRate.selectedIndex = 0;
				}
			}
		}
	} else {
		for (i = 0; i < children.length; i++) {
			if (parseFloat(children[i].innerHTML,10) > 115200) {
				children[i].disabled = false;
			}
		}
	}
}

function onOutputModeChanged( ev )
{
	setOutputMode();
}

function onConnectionChanged( ev )
{
	setFieldValue( 'RtcBridge-Field-Output-Mode', 232 );
	
	var field = YAHOO.util.Event.getTarget( ev );
	if ( field.value == 2 || field.value == 3 )
		setFieldValue( 'RtcBridge-Field-Output-Mode', 422 );
}