function updateStatusRadio()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateStatusRadio()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get status
			var status = data.StatusRadio;
			if (status == null) return;

			// Update values
			var value;

			// -- Internal Radio Type --
			setItemText('Internal-RadioType', formatRadioType(status.InternalRadio.RadioType, true));

			// -- Internal  Power --
			switch (status.InternalRadio.Power)
			{
            case 0: value = getResource('Radio-Resource-Off'); break;
            case 1: value = getResource('Radio-Resource-On'); break;
			default: value = status.InternalRadio.Power;
			}	
            setItemText('Internal-Power', value);
			
			// -- Internal  Power Management --
			switch (status.InternalRadio.PowerManagement)
			{
            case 0: value = getResource('Radio-Resource-No'); break;
            case 1: value = getResource('Radio-Resource-Yes'); break;
			default: value = status.InternalRadio.Power;
			}	
            setItemText('Internal-PowerManagement', value);

			// -- Internal Channel --
			var channel = findChannel(status.InternalRadio.ChannelTable, status.InternalRadio.ChannelNumber);
			setItemText('Internal-ChannelNumber', channel != null ? formatChannel(channel) : status.InternalRadio.ChannelNumber);

			// -- Internal Protocol --
			setItemText('Internal-Protocol', formatProtocol(status.InternalRadio.Protocol));

			// -- Internal Airlink Speed --
			setItemText('Internal-AirLinkSpeed', formatAirlinkSpeed(status.InternalRadio.AirLinkSpeed));
			
			// -- Internal Sensitivity --
			setItemText('Internal-Sensitivity', formatSensitivity(status.InternalRadio.Sensitivity));

            // -- Internal Scrambler --
            switch (status.InternalRadio.Scrambler)
			{
            case 0: value = getResource('Radio-Resource-Off'); break;
            case 1: value = getResource('Radio-Resource-On'); break;
			default: value = status.InternalRadio.Scrambler;
			}	
            setItemText('Internal-Scrambler', value);


			if (status.InternalRadio.Scrambler != null)
	            setItemText('Radio-IntScrambler', getResource('Radio-Resource-Scrambler'));
            else
            	setItemText('Radio-IntScrambler', '');	            	
            
            // -- Internal FEC --
            switch (status.InternalRadio.FEC)
			{
            case 0: value = getResource('Radio-Resource-Off'); break;
            case 1: value = getResource('Radio-Resource-On'); break;
			default: value = status.InternalRadio.FEC;
			}
            setItemText('Internal-FEC', value);
	        
			if (status.InternalRadio.FEC != null)
	            setItemText('Radio-IntFEC', getResource('Radio-Resource-FEC'));
			else
	            setItemText('Radio-IntFEC', '');

			// -- External Radio Type --
			setItemText('External-RadioType', formatRadioType(status.ExternalRadio.RadioType, false));

			// -- External Channel --
			channel = findChannel(status.ExternalRadio.ChannelTable, status.ExternalRadio.ChannelNumber);
			setItemText('External-ChannelNumber', channel != null ? formatChannel(channel) : status.ExternalRadio.ChannelNumber);

			// -- External Protocol --
			setItemText('External-Protocol', formatProtocol(status.ExternalRadio.Protocol));

			// -- External Airlink Speed --
			setItemText('External-AirLinkSpeed', formatAirlinkSpeed(status.ExternalRadio.AirLinkSpeed));

			// -- External Serial Port --
			setItemText('External-SerialPort', status.ExternalRadio.SerialPort);

			// -- External Serial Baud Rate --
			setItemText('External-SerialBaudRate', formatSerialBaudRate(status.ExternalRadio.SerialBaudRate));

			// -- External Serial Mode --
			setItemText('External-SerialMode', status.ExternalRadio.SerialMode);

			// -- External Serial RTS/CTS --
			switch (status.ExternalRadio.SerialRtsCts)
			{
            case 0: value = getResource('Radio-Resource-Off'); break;
            case 1: value = getResource('Radio-Resource-On'); break;
			default: value = status.ExternalRadio.SerialRtsCts;
			}	
            setItemText('External-SerialRtsCts', value);
            
            // -- External Scrambler --
            switch (status.ExternalRadio.Scrambler)
			{
            case 0: value = getResource('Radio-Resource-Off'); break;
            case 1: value = getResource('Radio-Resource-On'); break;
			default: value = status.ExternalRadio.Scrambler;
			}	
            setItemText('External-Scrambler', value);


			if (status.ExternalRadio.Scrambler != null)
	            setItemText('Radio-ExtScrambler', getResource('Radio-Resource-Scrambler'));
            else
            	setItemText('Radio-ExtScrambler', '');	            	
            
            // -- External FEC --
            switch (status.ExternalRadio.FEC)
			{
            case 0: value = getResource('Radio-Resource-Off'); break;
            case 1: value = getResource('Radio-Resource-On'); break;
			default: value = status.ExternalRadio.FEC;
			}
            setItemText('External-FEC', value);
	        
			if (status.ExternalRadio.FEC != null)
	            setItemText('Radio-ExtFEC', getResource('Radio-Resource-FEC'));
			else
	            setItemText('Radio-ExtFEC', '');

			// Update every 1 seconds
			setTimeout("updateStatusRadio()", 1000);
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateStatusRadio()", 1000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET',getStatusRadioURL, callbacks);
}

function findChannel(table, number)
{
	for (i in table)
	{
		if (table[i].ChannelIndex == number)
		{
			return table[i];
		}
	}
	
	return null;
}

function formatChannel(channel)
{
	var text = channel.ChannelIndex + ': ';
	if (channel.ReceiveFrequency > 0)
	{
		text += 'RX:' + channel.ReceiveFrequency.toFixed(4) + 'MHz ';
	}
	if (channel.TransmitFrequency > 0)
	{
		text += 'TX:' + channel.TransmitFrequency.toFixed(4) + 'MHz';
	}

	return text;
}

function formatRadioType(index, internal)
{
	switch (index)
	{
	case 0: return getResource('Radio-Resource-Type-NONE'); break;
	case 1: return getResource('Radio-Resource-Type-UNKNOWN'); break;
	case 2: return getResource(internal ? 'Radio-Resource-Type-MDL-Rx' : 'Radio-Resource-Type-MDL-TRx'); break;
	case 3: return getResource('Radio-Resource-Type-MGL'); break;
	case 4: return getResource('Radio-Resource-Type-PDL'); break;
	case 5: return getResource('Radio-Resource-Type-LFE'); break;
	case 6: return getResource('Radio-Resource-Type-LFA'); break;
	default: return index;
	}
}

function formatProtocol(index)
{
	switch (index)
	{
	case 0: return getResource('Radio-Resource-Protocol-Trannsparent'); break;
	case 1: return getResource('Radio-Resource-Protocol-Trimtalk'); break;
	case 2: return getResource('Radio-Resource-Protocol-DSNP'); break;
	default: return index;
	}
}

function formatSensitivity(index)
{
	switch (index)
	{
	case 0: return getResource('Radio-Resource-Sensitivity-Low'); break;
	case 1: return getResource('Radio-Resource-Sensitivity-Medium'); break;
	case 2: return getResource('Radio-Resource-Sensitivity-High'); break;
	default: return index;
	}
}

function formatAirlinkSpeed(index)
{
	switch (index)
	{
	case 4:  return "4800";
	case 16: return "7600";
	case 5:  return "9600";
	case 6:  return "19200";
	default: return index;
	}
}

function formatSerialBaudRate(index)
{
	switch (index)
	{
	case 2: return "1200";
	case 3: return "2400";
	case 4: return "4800";
	case 5: return "9600";
	case 6: return "19200";
	case 7: return "38400";
	default: return index;
	}
}
