var theGpsTableView = null, theGlonassTableView = null, theSbasTableView = null;

//START NEW LINES 1 --------------------------------------------------------------------------

//Tabs
var myTabs = null;

//GPS OK, GLONASS OK, SBAS OK, GPS NOT OK, GLONASS NOT OK, SBAS NOT OK
var colors = new Array("#00cc00", "#cc0000", "#007fff", "#8fcc8f", "#cc8f8f", "#8f8fcc");
//Bar Graphs
var theGpsBarGraph = null, theGlonassBarGraph = null, theSbasBarGraph = null;
//Constellation sizes
var consSize = new Array(32,24,18);
//dBHz Scale
var max = 60;

//barPapers related storage (check status and update)
var barPapers = new Array();
var oldBars = new Array(), dataBars = new Array();
var barL1RectSet = new Array(), barL2RectSet = new Array(), barUsedPathSet = new Array();
var barToolTipPathSet = new Array(), barToolTipTextSet = new Array();
var rectHover = new Array();
var barColsize = new Array();
var barElementId = new Array();
var formerK = null;
var initFinish = false;

//Polar view
var theSatellitePolarView = null;
var side, centerx, centery, radiusx, radiusy;
var colgps, colglonass, colsbas, colors;
var statusData;
var paper;
var textSet, rectSet, pathSet;
var legend;
var oldSats = new Object();
//END NEW LINES 1 --------------------------------------------------------------------------

var currentStatus = null;

function getGpsStatus()
{
	if (currentStatus != null)
	{
		return currentStatus.Gps;
	}
	else return [];
}

function getGlonassStatus()
{
	if (currentStatus != null)
	{
		return currentStatus.Glonass;
	}
	else return [];
}

function getSbasStatus()
{
	if (currentStatus != null)
	{
		return currentStatus.Sbas;
	}
	else return [];
}

function updateStatusSatellite()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateStatusSatellite()", 1000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get status
			var status = data.StatusSatellite;
			if (status == null) return;
			
			// Update values
			var value;

			// -- GPS enabled --
			switch (status.GpsEnabled)
			{
			case 0: value = getResource('Satellite-Resource-Off'); break;
			case 1: value = getResource('Satellite-Resource-On'); break;
			default: value = status.GpsEnabled;
			}	
			setItemText('Satellite-GpsEnabled', value);

			// -- GLONASS enabled --
			switch (status.GlonassEnabled)
			{
			case 0: value = getResource('Satellite-Resource-Off'); break;
			case 1: value = getResource('Satellite-Resource-On'); break;
			default: value = status.GlonassEnabled;
			}	
			setItemText('Satellite-GlonassEnabled', value);

			// -- SBAS enabled --
			switch (status.SbasEnabled)
			{
			case 0: value = getResource('Satellite-Resource-Off'); break;
			case 1: value = getResource('Satellite-Resource-On'); break;
			default: value = status.SbasEnabled;
			}	
			setItemText('Satellite-SbasEnabled', value);

			//-- Recording Elevation Mask --
            setItemText('Satellite-RecordingElevationMask', formatString( '{0} &deg;', status.RecordingElevationMask ) );

			//-- Recording Elevation Mask --
            setItemText('Satellite-PositionElevationMask', formatString( '{0} &deg;', status.PositionElevationMask ) );

			// -- Update current status --
			currentStatus = status;

			//START NEW LINES 2 --------------------------------------------------------------------------
			// -- Satellite tables --
			if (theGpsTableView == null)
			{
				var config = status.IsL2CTracked ? getGpsL2Config() : getGpsConfig();
				theGpsTableView = new SatelliteTableView('GpsTableView', getResource('Satellite-Resource-GPS'), getGpsStatus, config );
			}
			if (theGlonassTableView == null)
			{
				theGlonassTableView = new SatelliteTableView('GlonassTableView', getResource('Satellite-Resource-GLONASS'), getGlonassStatus, getGlonassConfig() );
			}
			if (theSbasTableView == null)
			{
				theSbasTableView = new SatelliteTableView('SbasTableView', getResource('Satellite-Resource-SBAS'), getSbasStatus, getSbasConfig() );
			}
			
			//Rapha�lJs
			
			//Polar View Initialization
			if (theSatellitePolarView == null)
			{
				//legend = 40;
				legend = 0;
				sidex = 600;
				sidey = 560;
				centerx = sidex / 2 - 20;
				centery = sidex / 2 - 40 + legend;
				marging = 40;
				radiusx = centerx - marging;
				radiusy = centery - marging;
				
				theSatellitePolarView = 'RaphaelSatellitePolarView';
					
				paper = Raphael(document.getElementById(theSatellitePolarView), sidex, sidey);
				
				paper.circle(centerx, centery, radiusx * 1 / 3);
				paper.circle(centerx, centery, radiusx * 2 / 3);
				paper.circle(centerx, centery, radiusx * 3 / 3);

				paper.text(centerx - 10, legend + 10, "0°");
				paper.text(centerx * 2 - 10, centery, "90°");
				paper.text(centerx - 10, centery * 2 - legend - 10, "180°");
				paper.text(10, centery, "270°");

				paper.text(centerx - 10, centery * 1 / 3 - 10, "30°");
				paper.text(centerx - 10, centery * 2 / 3 - 10, "60°");
				paper.text(centerx - 10, centery * 3 / 3 - 10, "90°");
				paper.path("M" + marging + " " + (radiusy + marging) +"L" + (radiusx * 2 + marging) + " " + (radiusy + marging));
				paper.path("M" + (radiusx + marging) + " " + (legend + marging  /2) +"L" + (radiusx + marging) + " " + (radiusy * 2 + marging / 2));
				
				paper.text(centerx * 1.75 - 20, centerx * 0.25 + 20 + legend * 0.5, "Az.");
				paper.text(centerx + 10, centery - 10, "El.");
				
				textSet = paper.set();
				rectSet = paper.set();
				pathSet = new Array();
			}
			
			if ((theGpsBarGraph == null) || (theGlonassBarGraph == null) || (theSbasBarGraph == null))
			{
				sidex = 620;
				sidey = 200;
				xpos = 25;
				ypos = 30;
				width = sidex - xpos * 4;
				height = sidey - ypos * 2;
			}
			
			//Gps Bar Graph
			if (theGpsBarGraph == null)
			{
				theGpsBarGraph = 'RaphaelGpsBarGraph';
				initBarGraph(theGpsBarGraph, sidex + 40, sidey, xpos, ypos, width, height, 0);
			}
			
			//Glonass Bar Graph
			if (theGlonassBarGraph == null)
			{
				theGlonassBarGraph = 'RaphaelGlonassBarGraph';
				initBarGraph(theGlonassBarGraph, sidex + 40, sidey, xpos, ypos, width, height, 1);
			}
			
			//Sbas Bar Graph
			if (theSbasBarGraph == null)
			{	
				theSbasBarGraph = 'RaphaelSbasBarGraph';
				
				initBarGraph(theSbasBarGraph, sidex + 40, sidey, xpos, ypos, width, height, 2);
			}
			
			statusData = new Array(status.Gps, status.Glonass, status.Sbas);
			updateSatellitePolarView(statusData, centerx, centery, radiusx);
			updateBarGraph(statusData, xpos, ypos, width, height);
			
			//YUI TabView (Tabs)
			if (myTabs == null)
			{
				myTabs = new YAHOO.widget.TabView("tabs");
			}
			
			// Update every (x / 1000) seconds
			if (initFinish == false)
			{
				setTimeout("updateStatusSatellite()", 1000);
			} else {
				setTimeout("updateStatusSatellite()", 5000);
				YAHOO.util.Dom.setStyle(document.getElementById('loading_msg'), "display", "none");
				YAHOO.util.Dom.setStyle(document.getElementById('SatelliteTableView'), "display", "block");
			}	
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateStatusSatellite()", 1000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET',getStatusSatelliteURL, callbacks);
}

function polarSat(prn, az, el, status, color, textcolor, constellation) {
    this.Prn = prn;
    this.Azimuth = az;
    this.Elevation = el;
    this.Status = status;
    this.Color = color;
    this.Textcolor = textcolor;
    this.Cons = constellation;
}

function barSat(prn, l1, l2, l1chan, l2chan, used, status, color, textcolor, constellation) {
    this.Prn = prn;
    this.L1 = l1;
    this.L2 = l2;
    this.L1Chan = l1chan;
    this.L2Chan = l2chan;
    this.Used = used;
    this.Status = status;
    this.Color = color;
    this.Textcolor = textcolor;
    this.Cons = constellation;
}

function initBarGraph(bargraphid, sidex, sidey, xpos, ypos, width, height, i) {	
	barPaper = Raphael(document.getElementById(bargraphid), sidex, sidey);
	
	//Element access for out of scope position event
	barElementId.push(bargraphid);
	
	//Bar Dyna
	barL1RectSet.push(new Array()); barL2RectSet.push(new Array()); barUsedPathSet.push(new Array());
	barToolTipPathSet.push(null); barToolTipTextSet.push(null);
	
	//Fixed drawings	
    //Grid
	barPaper.path("M" + (xpos) + "," + (ypos) + "L" + (xpos) + "," + (ypos + height)).attr("stroke-width", 2);
	
	colsize = Math.floor(width / consSize[i]);
	barColsize.push(colsize);
	width = colsize * consSize[i];
	barPaper.path("M" + (xpos - 1) + "," + (ypos + height) + "L" + (xpos + width + 1) + "," + (ypos + height));
	//Legend
	barPaper.text(xpos - 10, ypos - 10, getResource('Satellite-Resource-dBHz'));
	barPaper.text(xpos + width + 25, ypos + height + 5, getResource('Satellite-Resource-Satellites'));
	
	for (j = 0; j < consSize[i]; j++)
	{
		if (i == 2)
			prn = j + 120;
		else
			prn = j + 1;
		
		//X Axis
		barPaper.text(xpos + (j) * colsize + colsize / 2 + 2, ypos + height + 10, prn);
		
	    barL1RectSet[i].push(null);
	    barL2RectSet[i].push(null);
	    barUsedPathSet[i].push(null);
	}
	
	//Draw scale dBHz
	for (j = 0; j < max; j+=10)
	{
		barPaper.text(xpos - 15,Math.round(ypos + height - j / max * height),j);
		barPaper.path("M" + (xpos - 5) + "," + (ypos + height - j / max * (height - 2)) + "L" + (xpos) + "," + (ypos + height - j / max * (height - 2)));
	}
	
	//Raphael Dynamic
	barPapers.push(barPaper);
	
	//OldBars
	oldBars.push(null);
}

function updateBarGraph(data, xpos, ypos, width, height) {
	for (var i in data) {		
		if ((myTabs == null) || ((myTabs != null) && (myTabs.get('activeIndex') - 1 == i))) {
			colsize = Math.floor(width / consSize[i]);
			
			dataBars[i] = new Object();
			var nbNow = 0;
			
			for (var j in data[i]) {
				dat = data[i][j];
				//Up-to-date values
				//Not sure about SBAS modes at all
				if (dat.Status == 1) {
					used = true;
					color = colors[i];
					textcolor = "#FFFFFF";
				} else {
					used = false;
					color = colors[parseInt(i,10) + 3];
					textcolor = "#000000";
				}
				
				//L1
				l1 = dat.SnL1C;
				l1chan = "L1C";
				
				//L2C || L2P || 0
				l2 = 0;
				l2chan = "";
		        if (dat.SnL2C) {
			        l2 = dat.SnL2C;
			        l2chan = "L2C";
			    } else {
			        if (dat.SnL2P) {
			        	l2 = dat.SnL2P;
			        	l2chan = "L2P";
			        }
				}
		        
				dataBars[i][j] = new barSat(dat.Prn, l1, l2, l1chan, l2chan, used, dat.Status, color, textcolor, i);
				nbNow++;
			}
			
			//Fix satellites "long"
			//SNR are going to be refresh but "additional ones", have to remove useless ones (Before > Now).
			if (oldBars[i] != null) {
				var nbBefore = 0;
				for (var j in oldBars[i])
					nbBefore++;
					
				if (nbBefore > nbNow) {
					for (var j = nbNow; j < nbBefore; j++) {
						barL1RectSet[i][j].remove();
						barL1RectSet[i][j] = null;
						
						if (oldBars[i][j].L2 > 0) {
							barL2RectSet[i][j].remove();
							barL2RectSet[i][j] = null;
						}
					}
				}
			}
			
			/*
			if (info.Prn > oldBars[i][k].Prn)
			barL1RectSet[i][k].remove();
			barL1RectSet[i][k] = null;
			 */
			
			for (var k in dataBars[i]) {
				info = dataBars[i][k];
				
				if (i == 2)
					prn = info.Prn - 120;
				else
					prn = info.Prn - 1;
				
				colheight1 = (info.L1 / max) * (height - 2);
				colheight2 = (info.L2 / max) * (height - 2);
				topleft = (ypos - 1 + height - colheight1);
				
				//L1 Rect
				if (info.L1 > 0) {					
					if ((barL1RectSet[i][k] == null) || (oldBars[i] == null) || (oldBars[i][k] == null) || (oldBars[i][k].L1 == 0)) {
						barL1RectSet[i][k] = barPapers[i].rect(xpos + (prn) * (colsize) + 5, ypos - 1 + height - colheight1, colsize - 6, colheight1).attr("fill", info.Color);
					} else if (info.Prn != oldBars[i][k].Prn) {
						barL1RectSet[i][k].remove();
						barL1RectSet[i][k] = null;
						barL1RectSet[i][k] = barPapers[i].rect(xpos + (prn) * (colsize) + 5, ypos - 1 + height - colheight1, colsize - 6, colheight1).attr("fill", info.Color);
					} else if (info.L1 != oldBars[i][k].L1) {
						barL1RectSet[i][k].attr("y",(ypos - 1 + height - colheight1));
						barL1RectSet[i][k].attr("height", colheight1);
					}
				} else {
					if ((oldBars[i] != null) && (oldBars[i][k] != null) && (oldBars[i][k].L1 > 0)) {
						barL1RectSet[i][k].remove();
						barL1RectSet[i][k] = null;
					}
				}
				
				//L2 Rect
				if (info.L2 > 0) {
					if ((barL2RectSet[i][k] == null) || (oldBars[i] == null) || (oldBars[i][k] == null) || (oldBars[i][k].L2 == 0)) {
						barL2RectSet[i][k] = barPapers[i].rect(xpos + (prn) * (colsize) + 5, ypos - 1 + height - colheight2, colsize - 6, colheight2).attr("fill", info.Color);
					} else if (info.Prn != oldBars[i][k].Prn){
						barL2RectSet[i][k].remove();
						barL2RectSet[i][k] = null;
						barL2RectSet[i][k] = barPapers[i].rect(xpos + (prn) * (colsize) + 5, ypos - 1 + height - colheight2, colsize - 6, colheight2).attr("fill", info.Color);	
					} else if (info.L2 != oldBars[i][k].L2)	{
						barL2RectSet[i][k].attr("y",(ypos - 1 + height - colheight2));
						barL2RectSet[i][k].attr("height", colheight2);
					}
				} else {
					if ((oldBars[i] != null) && (oldBars[i][k] != null) && (oldBars[i][k].L2 > 0)) {
						barL2RectSet[i][k].remove();
						barL2RectSet[i][k] = null;
					}
				}
				
				//Color update
				if ((barL1RectSet[i][k] != null) && (oldBars[i] != null) && (oldBars[i][k] != null) && (info.Color != oldBars[i][k].Color))	{
					barL1RectSet[i][k].attr("fill", info.Color);
					
					if (barL2RectSet[i][k] != null)
						barL2RectSet[i][k].attr("fill", info.Color);
				}
			}
			
			//ToolTip
			if (barToolTipPathSet[i] == null) {
				rectHover[i] = barPapers[i].rect(xpos, ypos, width, height).attr({ stroke: "none", fill: "yellow", opacity: 0 });
				
			    //Init ToolTip
				basex = 50; 
				basey = 50;
				tipWidth = 100;
				diag = 25;
				color = "#FFFFFF";//"#4E8ABE";
				//ToolTip Path
				barToolTipPathSet[i] = barPapers[i].path("M" + (basex) + "," + (basey) + "L" + (basex + diag) + "," + (basey - diag) + "L" + (basex + diag + tipWidth) + "," + (basey - diag) + "L" + (basex + diag + tipWidth) + "," + (basey + diag) + "L" + (basex + diag) + "," + (basey + diag) + " z").attr({stroke: color, "stroke-width": 2, fill: "#000000", opacity: 0.75});
				//ToolTip Text
				barToolTipTextSet[i] = barPapers[i].text(basex + diag + tipWidth / 2, basey,"").attr({fill:color, "font-size": 11});
				
				//Hide
				barToolTipPathSet[i].hide();
				barToolTipTextSet[i].hide();
	
				rectHover[i].mousemove(function (event) {
					index = myTabs.get('activeIndex') - 1;
					cols = barColsize[index];
					
					left = event.clientX - YAHOO.util.Dom.getDocumentScrollLeft() - YAHOO.util.Dom.getX(barElementId[index]) - xpos;
					leftpos = Math.round((left + (barColsize[index] - 5) / 2));
					
					min = 99999;
					indK = null;
					
					for (var k in dataBars[index]) {
						info = dataBars[index][k];
						if (info.L1 > 0) {
							if (index == 2)
								prn = info.Prn - 120;
							else
								prn = info.Prn - 1;
							
							kpos = prn * cols + cols * 0.75 + 2;
							val = Math.abs(kpos - leftpos);
							if (val > min) {
								break;
							} else {
								min = val;
								indK = k;
							}
						}
					}
					
					if (formerK != indK) {
						info = dataBars[index][indK];
						
						if (index == 2)
							prn = info.Prn - 120;
						else
							prn = info.Prn - 1;
						
						//New values
						//X
						newX = xpos + (prn + 1) * (cols);
						
						//Y
						maxcolheight = Math.max(colheight1 = (info.L1 / max) * height,(info.L2 / max) * height);
						newY = Math.round(ypos + height - maxcolheight);// / 2);
						
						//Former values
						formerPath = barToolTipPathSet[index].attr("path") + "";
						//"M" + x + "," + y + "L" + ...
						formerX = parseInt(formerPath.substring(1, formerPath.indexOf(",")),10);
						formerY = parseInt(formerPath.substring(formerPath.indexOf(",") + 1, formerPath.indexOf("L")),10);
						moveX = Math.round(newX - formerX);
						moveY = Math.round(newY - formerY);
						//Path Tanslation bug in current release using ie8
						//Use path change instead
						//http://groups.google.com/group/raphaeljs/browse_thread/thread/72245b7c61360ae5/f407390c72eca046?lnk=gst&q=+Inconsistency+in+path#f407390c72eca046
						//barToolTipPathSet[index].translate(moveX, moveY);
						
						barToolTipPathSet[index].attr("path","M" + (newX) + "," + (newY) + "L" + (diag + newX) + "," + (- diag + newY) + "L" + (+ diag + tipWidth + newX) + "," + (- diag + newY) + "L" + (+ diag + tipWidth + newX) + "," + (+ diag + newY) + "L" + (+ diag + newX) + "," + (+ diag + newY) + " z");
						barToolTipTextSet[index].translate(moveX, moveY);
						
						//Text change
						switch(info.Status) {
							case 1:
							case 2:
							case 3:
								value = getResource( 'Satellite-Resource-Status-Used');
								break;
							case 16:
								value = getResource( 'Satellite-Resource-Status-NoEphemeris');
								break;
							case 18:
							case 22:
								value = getResource( 'Satellite-Resource-Status-Unhealthy');
								break;
							case 21:
								value = getResource( 'Satellite-Resource-Status-BadURA');
								break;
							default:
								value = '';
								break;
						}
						ttiptext = value;
						ttiptext += "\n" + info.L1Chan + ": " + info.L1;
						if (info.L2 > 0)
							ttiptext += "\n" + info.L2Chan + ": " + info.L2;
						
						barToolTipTextSet[index].attr("text",ttiptext);
						
					    //Show
						barToolTipPathSet[index].toFront();
						barToolTipTextSet[index].toFront();
						rectHover[index].toFront();
						barToolTipPathSet[index].show();
						barToolTipTextSet[index].show();
					}
					formerK = indK;
				});
				
				rectHover[i].mouseout(function (event) {
					formerK = null;
					index = myTabs.get('activeIndex') - 1;
					//Hide
					barToolTipPathSet[index].hide();
					barToolTipTextSet[index].hide();
				});
				
			}
			
			//Important: enable events all over the area
			barToolTipPathSet[i].toFront();
			barToolTipTextSet[i].toFront();
			rectHover[i].toFront();
			
			//Backup for next update cycle
			oldBars[i] = dataBars[i];
		}
	}

	initFinish = true;
}
 
function updateSatellitePolarView(data, centerx, centery, radius)
{	
	if ((myTabs == null) || ((myTabs != null) && (myTabs.get('activeIndex') == 4))){
		//New source code (Internet Explorer Performance Optimization)
		var dataSats = new Object();
	
		var indData = new Array();
		var toAddSats = new Object();
		
		var indOld = new Array();
		var toDelSats = new Object();
		
		var ind = 0;
		
		//Out filter "undefined" Satellites
		for (var i in data){
			for (var j in data[i]){
				dat = data[i][j];
				//Up-to-date values
				if (dat.Status == 1){
					color = colors[i];
					textcolor = "#FFFFFF";
				} else {
					color = colors[parseInt(i,10) + 3];
					textcolor = "#000000";
				}
				dataSats[ind] = new polarSat(dat.Prn + "", dat.Azimuth, dat.Elevation, dat.Status, color, textcolor, i);
				ind++;
			}
		}
	
		//Check frozen satellites.	
		for (var i in dataSats){
			dat = dataSats[i];
			for (var j in oldSats){
				oldat = oldSats[j];
				if (dat.Prn == oldat.Prn && dat.Azimuth == oldat.Azimuth && dat.Elevation == oldat.Elevation && dat.Color == oldat.Color)
				{
					//Index of frozen Satellite in Data Array
					indData.push(i);
					//Index of frozen Satellite in Old Array
					indOld.push(j);
					
					break;
				}
			}
		}
		
		//Keep new or updated Satellite in Data Array (to draw satellites)
		ind = 0;
		for (var i in dataSats){	
			found = false;
			for (var j in indData)
				if (indData[j] == i)
					found = true;
			
			if (found == false){
				toAddSats[ind] = dataSats[i];
				ind++;
			}
		}
		
		//Keep former or updated Satellite in Old Array (to remove satellites)
		ind = 0;
		for (var i in oldSats){
			found = false;
			for (var j in indOld)
				if (indOld[j] == i)
					found = true;
			
			if (found == false){
				toDelSats[ind] = oldSats[i];
				ind++;
			}
		}
		
		//Backup for next update cycle
		oldSats = dataSats;
		
		for (var i in toDelSats){
			for (j = 0; j < textSet.items.length; j++){
				tex = textSet.items[j];
				rec = rectSet.items[j];
				if ((tex.attr("text") == toDelSats[i].Prn) && (rec.attr("fill") == toDelSats[i].Color)){
					tex.remove();
					rec.remove();
					
					if (pathSet[j] != null)
						pathSet[j].remove();
					
					break;
				}
			}
		}
		
		//Draw	
		for (var i in toAddSats){
			addInfo = toAddSats[i];
			
			evdist = radiusx * ((90 - addInfo.Elevation) / 90);
			radAzimuth = (addInfo.Azimuth * Math.PI) / 180;
			api = radAzimuth + Math.PI / 2;
			ecosapi = evdist * Math.cos(api);
			esinapi = evdist * Math.sin(api);
			
			if (radAzimuth < Math.PI) {
			    if (radAzimuth % 1 < 0.5 * Math.PI) {
			    	xrect = centerx - ecosapi;
			    } else {
			    	xrect = centerx + ecosapi;
			    }
			} else {
			    xrect = centerx - ecosapi;
			}
	
			if (radAzimuth % 1 < 0.5 * Math.PI) {
			    yrect = centery - esinapi;
			} else {
			    yrect = centery + esinapi;
			}
			
			rectSet.push(paper.rect(xrect - 10, yrect - 10, 20, 20).attr("fill", addInfo.Color));
			
			if (addInfo.Status == 1)
			{
				pathSet.push(null);
			} else {
				pathSet.push(paper.path("M" + (xrect - 10) + "," + (yrect - 10)+ "L" + (xrect + 10) + "," +  (yrect + 10)));
			}
			
			textSet.push(paper.text(xrect, yrect + 2, addInfo.Prn).attr("fill", addInfo.Textcolor));
		}
	}
}
//END NEW LINES 2 --------------------------------------------------------------------------

function SatelliteTableView(id, caption, source, config )
{
	// Columns definition
	var baseColumnDefs = 
	[
		{label:getResource('Satellite-Resource-Prn'), key:"Prn", resizeable:true},
		{label:getResource('Satellite-Resource-Status'), key:"Status", formatter:SatelliteTableView.formatStatus, resizeable:true},
		{label:getResource('Satellite-Resource-Azimuth'), key:"Azimuth", resizeable:true},
		{label:getResource('Satellite-Resource-Elevation'), key:"Elevation", resizeable:true},
		{label:getResource('Satellite-Resource-SN'), formatter:SatelliteTableView.formatSn, 
			children: config["SnColumnDefs"]
		},
		{label:getResource('Satellite-Resource-Smooth'), formatter:SatelliteTableView.formatSmooth, 
			children: config["SmoothColumnDefs"]
		}
	];

	// Fields
	var baseFields = ["Prn", "Status", "Azimuth", "Elevation"];
	
	// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema = baseFields.concat( config["fields"] );

	// Table configs
	var myConfigs = {
		//Caption are useless since it's the same label as YUI Tab
		//caption:caption
	};
	
	// Localized messages
	myConfigs.MSG_EMPTY = getResource('Satellite-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('Satellite-Resource-Loading');

	// Create table
	var myDataTable = new YAHOO.widget.DataTable(id, baseColumnDefs, myDataSource, myConfigs);
	// Set up polling
	var myCallback =
	{
		success: myDataTable.onDataReturnInitializeTable,
		failure: function()
		{
			YAHOO.log("SatelliteTableView: Polling failure", "error");
		},
		scope: myDataTable
	};
	myDataSource.setInterval(1000, null, myCallback);
}

function getGpsConfig()
{
	var config = new Object();
	config["SnColumnDefs"] = 
	[
		{label:"L1C", key:"SnL1C", resizeable:true},
		{label:"L1P(Y)", key:"SnL1P", resizeable:true},
		{label:"L2P(Y)", key:"SnL2P", resizeable:true}
	];
	config["SmoothColumnDefs"] = 
	[
		{label:"L1C", key:"SnL1CSmooth", resizeable:true},
		{label:"L1P(Y)", key:"SnL1PSmooth", resizeable:true},
		{label:"L2P(Y)", key:"SnL2PSmooth", resizeable:true}
	];
	config["fields"] = ["SnL1C", "SnL1P", "SnL2P", "SnL1CSmooth", "SnL1PSmooth", "SnL2PSmooth"];
	return config;
}

function getGpsL2Config()
{
	var config = new Object();
	config["SnColumnDefs"] = 
	[
		{label:"L1C", key:"SnL1C", resizeable:true},	
		{label:"L2C", key:"SnL2C", resizeable:true}
	];
	config["SmoothColumnDefs"] = 
	[
		{label:"L1C", key:"SnL1CSmooth", resizeable:true},
		{label:"L2C", key:"SnL2CSmooth", resizeable:true}
	];
	config["fields"] = ["SnL1C", "SnL2C", "SnL1CSmooth", "SnL2CSmooth"];
	return config;
}

function getGlonassConfig()
{
	return getGpsL2Config();
}

function getSbasConfig()
{
	var config = new Object();
	config["SnColumnDefs"] = 
	[
		{label:"L1C", key:"SnL1C", resizeable:true}
	];
	config["SmoothColumnDefs"] = 
	[
		{label:"L1C", key:"SnL1CSmooth", resizeable:true}
	];
	config["fields"] = ["SnL1C", "SnL1CSmooth"];
	return config;
}

SatelliteTableView.formatStatus = function(el, oRecord, oColumn, oData)
{
	try
	{
		var value = "";
		var resId = "Satellite-Resource-Status-";
		switch(oData)
		{
			case 1:
			case 2:
			case 3:
				value = getResource( resId + 'Used');
				break;
			case 16:
				value = getResource( resId + 'NoEphemeris');
				break;
			case 18:
			case 22:
				value = getResource( resId + 'Unhealthy');
				break;
			case 21:
				value = getResource( resId + 'BadURA');
		}
		el.innerHTML = value;
	}
	catch (x) {
		YAHOO.log("SatelliteTableView.formatUsage: '" + oData + "' bad format");
	}
};

SatelliteTableView.formatSn = function(el, oRecord, oColumn, oData)
{
	try
	{
		el.innerHTML = oData > 0 ? oData : "";
	}
	catch (x) {
		YAHOO.log("SatelliteTableView.formatSn: '" + oData + "' bad format");	
	}
};

SatelliteTableView.formatSmooth = function(el, oRecord, oColumn, oData)
{
	try
	{
		el.innerHTML = oData > 0 ? oData : "";
		if ( oData > 254 )
		{
			el.innerHTML = ">255";
		}
	}
	catch (x) {
		YAHOO.log("SatelliteTableView.formatSmooth: '" + oData + "' bad format");	
	}
};